<!DOCTYPE html>

<html>

<head>
    {{ template "prelude" }}

    <script>
        const DATA_CUBE = "datacube:8085";

        if (options.instance === null) {
            options.instance = DATA_CUBE;
        }

        document.title = `Containers (${options.instance})`;

        const metrics_selector = `instance=\"${options.instance}\",name!=\"\"`;

        async function load_cpu_plot() {
            const data = await load_time_series(
                `rate(container_cpu_usage_seconds_total{${metrics_selector}}[2m])`,
                metric => metric["name"],
            );

            Plotly.newPlot(
                document.getElementById("cpu"),
                stacked(data),
                {
                    title: "CPU-Auslastung",
                    yaxis: {
                        tickformat: ',.0%',
                        range: [0, 2],
                    },
                    showlegend: true,
                }
            );
        }

        async function load_ram_plot() {
            const data = await load_time_series(
                `container_memory_usage_bytes{${metrics_selector}} / container_spec_memory_limit_bytes{${metrics_selector}}`,
                metric => metric["name"],
            );

            Plotly.newPlot(
                document.getElementById("ram"),
                stacked(data),
                {
                    title: "RAM-Auslastung",
                    yaxis: {
                        tickformat: ',.0%',
                        range: [0, 1],
                    },
                    showlegend: true,
                }
            );
        }

        async function load_net_plot() {
            var data = await load_time_series(
                `rate(container_network_receive_bytes_total{${metrics_selector}}[2m]) / 1024 / 1024`,
                metric => "recv/" + metric["name"],
            );

            data = data.concat(await load_time_series(
                `rate(container_network_transmit_bytes_total{${metrics_selector}}[2m]) / 1024 / 1024`,
                metric => "send/" + metric["name"],
            ));

            Plotly.newPlot(
                document.getElementById("net"),
                stacked(data),
                {
                    title: "Netzwerk-Verkehr",
                    yaxis: {
                        ticksuffix: "MB/s",
                    },
                    showlegend: true,
                }
            );
        }

        async function load_disk_plot() {
            var data = await load_time_series(
                `rate(container_fs_reads_bytes_total{${metrics_selector}}[2m]) / 1024 / 1024`,
                metric => "read/" + metric["name"],
            );

            data = data.concat(await load_time_series(
                `rate(container_fs_writes_bytes_total{${metrics_selector}}[2m]) / 1024 / 1024`,
                metric => "write/" + metric["name"],
            ));

            Plotly.newPlot(
                document.getElementById("disk"),
                stacked(data),
                {
                    title: "Festplatten-Durchsatz",
                    yaxis: {
                        ticksuffix: "MB/s",
                    },
                    showlegend: true,
                }
            );
        }

        async function load_health_plot() {
            if (options.instance !== DATA_CUBE) {
                return;
            }

            var data = await load_time_series(
                "datacube_health{job=\"datacube_proxy\"}",
                metric => metric["service"],
            );

            Plotly.newPlot(
                document.getElementById("health"),
                data,
                {
                    title: "API Health Status",
                    yaxis: {
                        ticksuffix: "",
                    },
                    showlegend: true,
                }
            );
        }

        async function load_plots() {
            await Promise.all([
                load_cpu_plot(),
                load_ram_plot(),
                load_net_plot(),
                load_disk_plot(),
                load_health_plot(),
            ]);
        }

        window.onload = load_plots;

        if (options.update_interval > 0) {
            window.setInterval(load_plots, options.update_interval * 1000);
        }
    </script>

    <style>
        body {
            font-family: sans-serif;
        }

        table {
            width: 100%;
        }

        td {
            width: 50%;
        }
    </style>
</head>

<body>
    <table>
        <tr>
            <td id="cpu"></td>
            <td id="ram"></td>
        </tr>
        <tr>
            <td id="net"></td>
            <td id="disk"></td>
        </tr>
        <tr>
            <td id="health"></td>
        </tr>
    </table>
</body>

</html>